       //----------------------------------------------------------------------
       // Sample Program To Consume the CurrencyConversion Web Service
       // Using the RPGLE Stub Service Program "CURRENCY"
       //
       // Create using: CRTRPGMOD MODULE(mylib/CURRCONV)
       //                         SRCFILE(mylib/QRPGLESRC)
       //                         SRCMBR(CURRCONV)
       //                         REPLACE(*NO)
       //                           INCDIR('/home/myfolder')
       //
       //               CRTPGM PGM(mylib/CURRCONV)
       //                      BNDSRVPGM((mylib/CURRENCY)
       //
       //
       //----------------------------------------------------------------------

       // The include members below are created by WSDL2RPG
      /copy CurrencyConvertorSoap.rpgleinc
      /copy CurrencyConvertorSoap_util.rpgleinc

     d ws_ds           ds                  likeds(This_t) inz
     d amount          ds                  likeds(xsd_double)
     d fromCode        ds                  likeds(xsd_string)
     d toCode          ds                  likeds(xsd_string)
     d decAmt          s             13  2

     d rtnInd          s              1n
      /free

       // Define our "FROM" and "TO" Currency Codes based on
       // Constants defined to the web service stub
       fromCode.value = Currency_USD;
       toCode.value = Currency_CAD;

       // Create a connection to the web service
       if stub_create_CurrencyConvertorSoap(ws_ds);

          // Call the web service conversion rate operation
          rtnInd = stub_op_ConversionRate( ws_ds
                                   : fromCode
                                   : toCode
                                   : amount);

          // Convert and display the returned conversion rate
          decAmt = %dec(amount.value: 13:2);
          if rtnInd and not amount.isNil;
             dsply %char(decAmt);
          endif;

          // Close the web service connection
          stub_destroy_CurrencyConvertorSoap(ws_ds);
       else;
          dsply %subst(ws_ds.excString:1:50);
       endif;

       *inlr = *on;
       return;
      /end-free
